#if !defined(AFX_DATAVIEW_H__820843E1_7D07_4119_8D45_B0725BD81CA2__INCLUDED_)
#define AFX_DATAVIEW_H__820843E1_7D07_4119_8D45_B0725BD81CA2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DataView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDataView view
#include "XMalloc.h"

#pragma warning(disable: 4786)
#include <vector>

typedef  void (* CallBackFunc) (int x,int y,char *buf,void *p); 

class CDataView : public CScrollView
{
public:

	CDataView();
	virtual ~CDataView();

	int OnCreate(LPCREATESTRUCT lpCreateStruct); 
	
	BOOL   Create(RECT &rc,CWnd *pParent,int row,int col,CallBackFunc pFunc,void *p);

	//{{AFX_VIRTUAL(CDataView)
	protected:
	virtual void OnDraw(CDC* pDC); 
	virtual void OnInitialUpdate();
	virtual BOOL OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll = TRUE);
	virtual BOOL OnScrollBy(CSize sizeScroll, BOOL bDoScroll = TRUE);
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL


protected:

	DECLARE_DYNCREATE(CDataView)

	inline char *GetData(int row,int col);
	
    void  DrawData(CDC* pDC,const CPoint &ptScroll);
    void  DrawHeader(CDC* pDC,const CPoint &ptScroll);
	void  RegionToRowCol(const RECT &rcRegion,RECT &rcRowCol);
	void  UpdataActiveData();

	//{{AFX_MSG(CDataView)
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CallBackFunc   m_pFunc;
	void  *        m_pVoid;

	CPen     m_pen;
	CFont    m_font;

	std::vector<int> m_col_w; //ÿеĿ.
	std::vector<int> m_row_h; //ÿеĸ߶.

	RECT   m_rcRowCol; //ǰʾзΧ.(m_rcRowColĩ߽ʾҲҪʾ)
    RECT   m_rcRegion; //ǰʾ.()

	char * m_active[50][50];//ͬʱʾ2500Ԫ.

    CMalloc m_malloc;//ڴ,ִڴƬ.
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATAVIEW_H__820843E1_7D07_4119_8D45_B0725BD81CA2__INCLUDED_)
