#include "StdAfx.h"
#include "XMalloc.h"

CMalloc::CMalloc(int n,int size):m_count(n),m_size(size)
{
	m_buf = (char *)::malloc(n*size);

	for(int i=0;i<n;++i)//ʼʱеĿ鶼δʹ.
	  m_flag.insert(i);
}

CMalloc::~CMalloc()
{
	m_flag.clear();
	::free(m_buf);
}

void *CMalloc::malloc(int size)
{
	if(size<=m_size)
	{
		if(!m_flag.empty())//ڻһδʹڴ.
		{
			std::set<int>::iterator pos = m_flag.begin();

			char *temp = m_buf+m_size*(*pos);

			m_flag.erase(pos);

			return temp;
		}
	}

	return ::malloc(size);
}

void CMalloc::free(void *p)
{
	int index = ((char *)p-m_buf)/m_size;

	if(index>=0 && index<m_count)//ǻеڴ.
	{
		m_flag.insert(index);
		return;
	}

    ::free(p);
}